//+------------------------------------------------------------------+
//|                                              MA&RSIExpert_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"


//---- input parameters
extern string     Expert_Name    = "---- MA&RSIExpert_v1 ----";

extern int        Magic          = 10000;
extern int        Slippage       =     6;

extern string     Main_data      = " Trade Volume & Trade Method";
extern double     Lots           =   0.1;
extern double     TakeProfit     =     0;    // Take Profit Value 
extern double     InitialStop    =   150;    // Initial Stop Value
extern double     TrailingStop   =    20;    // Trailing Stop Value   

extern string     Inputs         = " MAs & RSI parameters ";
extern int        MainTimeFrame  =    60;    // Large Time Frame in min
extern int        SMAPeriod      =     5;    // 
extern int        EMAPeriod      =    10;    // 
extern int        EMAShift       =     0;
extern int        SMABarsBack    =     0;    // 
extern int        EMABarsBack    =     6;
extern int        RSIPeriod      =    10;
extern double     EntryLevel     =     0; 

extern string     MM_inputs      = " MoneyManagement by L.Williams ";
extern bool       MM             = false;    //  Switch
extern double     MMRisk         =  0.15;    // Risk Factor
extern double     MaxLoss        =  1000;    // Maximum Loss by 1 Lot


double SellStop,BuyStop,SellProfit,BuyProfit;
bool   BuySignal = false, SellSignal = false;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }

// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}  

void TradeSignal()
{         

   double sma=iMA(NULL,0,SMAPeriod,0,MODE_SMA,PRICE_CLOSE,0) ;
   double ema=iMA(NULL,0,EMAPeriod,EMAShift,MODE_EMA,PRICE_CLOSE,6);
   double rsi1=iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,0);
   double rsi2=iRSI(NULL,0,RSIPeriod,PRICE_CLOSE,1);

   BuySignal = (  
               Ask>sma 
               && 
               (ema-sma)<5*Point 
               && 
               rsi1<51 
               && 
               rsi1>rsi2 
               && 
               (sma-Ask)<EntryLevel*Point
               );
  
   SellSignal= (  
               Bid<sma 
               && 
               (sma-ema)<5*Point 
               && 
               rsi1>49 
               && 
               rsi1<rsi2 
               && 
               (Bid-sma)<EntryLevel*Point
               );
} 


double MoneyManagement ( bool flag, double Lots, double risk, double maxloss)
{
   double Lotsi=Lots;
	    
   if ( flag ) Lotsi=Lots*NormalizeDouble(Lots*AccountFreeMargin()*MMRisk/MaxLoss,1);   
     
   if (Lotsi<0.1) Lotsi=0.1;  
   return(Lotsi);
}   


void TrailStop()
{
   for (int cnt=0;cnt<OrdersTotal();cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY) 
         {
			BuyStop = Bid - TrailingStop*Point;
			   if( OrderOpenPrice() < BuyStop || OrderStopLoss() == 0 ) 
            {   
			      if ( BuyStop > OrderStopLoss() ) 
			      {
			      bool result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                                NormalizeDouble(BuyStop, Digits),
			                                OrderTakeProfit(),0,LightGreen);
			         if( !result )
                  {
                  Print("BUY: OrderModify failed with error #",GetLastError());
                  }
			      return(0);
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
         SellStop = Ask + Point * TrailingStop;   
            if( OrderOpenPrice() > SellStop) 
            {
               if( OrderStopLoss() > SellStop || OrderStopLoss() == 0 ) 
               {
               OrderModify(OrderTicket(), OrderOpenPrice(),
                           NormalizeDouble(SellStop, Digits),
			                  OrderTakeProfit(),0,DarkOrange);
                  if( !result )
                  {
                  Print("SELL: OrderModify failed with error #",GetLastError());
                  }
               return(0);
               }   
   			}	    
         }
      }
   }     
}

// ---- Open Sell Orders
void SellOrdOpen()
{		     
   double SellPrice = Bid;
   double StopPrice = Ask;
   int    Mode = OP_SELL;
        	  
	  if (InitialStop > 0) SellStop  = StopPrice + InitialStop*Point; 
	                       else SellStop = 0;
     if (TakeProfit  > 0) SellProfit = SellPrice - TakeProfit*Point; 
                          else SellProfit=0;
	int ticket = OrderSend( Symbol(),Mode,MoneyManagement ( MM, Lots, MMRisk, MaxLoss),
	                    NormalizeDouble(SellPrice , Digits),
	                    Slippage,
	                    NormalizeDouble(SellStop  , Digits),
	                    NormalizeDouble(SellProfit, Digits),
	                    "sell",Magic,0,Red);
      if(ticket<0)
      {
      Print("SELL: OrderSend failed with error #",GetLastError());
      }
   return(0);
}
// ---- Open Buy Orders
void BuyOrdOpen()
{		     
   double BuyPrice = Ask;
   double StopPrice = Bid;
   int    Mode     = OP_BUY;
      
      if (InitialStop > 0) BuyStop  = StopPrice - InitialStop*Point; 
		                     else BuyStop = 0;
      if (TakeProfit  > 0) BuyProfit= BuyPrice + TakeProfit*Point;  
                           else BuyProfit=0;  
		 
	int ticket = OrderSend(Symbol(),Mode, MoneyManagement ( MM, Lots, MMRisk, MaxLoss),
	                   NormalizeDouble(BuyPrice , Digits),
	                   Slippage,
	                   NormalizeDouble(BuyStop  , Digits), 
	                   NormalizeDouble(BuyProfit, Digits),
	                   "buy",Magic,0,Blue);
      if(ticket<0)
      {
      Print("BUY : OrderSend failed with error #",GetLastError());
      }
   return(0);
} 

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  if(Bars<100 || IsTradeAllowed()==false) return; 
      
  if(AccountFreeMargin()< 1000*MoneyManagement(MM,Lots,MMRisk,MaxLoss))
  {
  Print("We have no money. Free Margin = ", AccountFreeMargin());
  return(0);  
  }  
  
  TradeSignal();
  if ( TrailingStop > 0 ) TrailStop();
   
  if (ScanTrades()<1 && BuySignal ) BuyOrdOpen() ;
  if (ScanTrades()<1 && SellSignal) SellOrdOpen();
  
//----
   return(0);
} //start()
//+------------------------------------------------------------------+